unit Unit4;

interface

uses
  Winapi.Windows,
  System.Classes,
  Vcl.Forms, Vcl.Controls, Vcl.Graphics,
  Data.DB, Data.Win.ADODB,
  DBGridEhGrouping, ToolCtrlsEh, DBGridEhToolCtrls, DynVarsEh, MemTableDataEh, DataDriverEh,
  ADODataDriverEh, MemTableEh, EhLibVCL, GridsEh, DBAxisGridsEh, DBGridEh;

type
  TForm4 = class(TForm)
    DataSource1: TDataSource;
    DBGridEh1: TDBGridEh;
    MemTableEh1: TMemTableEh;
    ADODataDriverEh1: TADODataDriverEh;
    procedure DBGridEh1DataGroupGetRowText(Sender: TCustomDBGridEh; GroupDataTreeNode: TGroupDataTreeNodeEh;
      var GroupRowText: string);
    procedure DBGridEh1AdvDrawDataCell(Sender: TCustomDBGridEh; Cell, AreaCell: TGridCoord; Column: TColumnEh;
      const ARect: TRect; var Params: TColCellParamsEh; var Processed: Boolean);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form4: TForm4;

implementation

{$R *.dfm}

procedure TForm4.DBGridEh1AdvDrawDataCell(Sender: TCustomDBGridEh; Cell, AreaCell: TGridCoord; Column: TColumnEh;
  const ARect: TRect; var Params: TColCellParamsEh; var Processed: Boolean);
begin
  if not Column.Field.IsNull then
  begin
    Sender.Canvas.Brush.Color := clWhite;
    Sender.Canvas.FillRect(ARect);
    if Column.Index = 0 then
      Sender.Canvas.Pen.Color := clSkyBlue
    else
      Sender.Canvas.Pen.Color := clWebTan;
    Sender.Canvas.Brush.Color := Sender.Canvas.Pen.Color;
    Sender.Canvas.RoundRect(ARect, 30, 30);
    Sender.DrawColumnDataCellMainContent(Cell, AreaCell, Column, ARect, Params, ARect);
    Processed := True;
  end;
end;

procedure TForm4.DBGridEh1DataGroupGetRowText(Sender: TCustomDBGridEh; GroupDataTreeNode: TGroupDataTreeNodeEh;
  var GroupRowText: string);
begin
  GroupRowText := StringOfChar(' ', 90) + Sender.Columns[2].Field.AsString;
end;

procedure TForm4.FormCreate(Sender: TObject);
begin
  MemTableEh1.Active := True;
end;

end.
